<?php
declare(strict_types = 1);

class_exists('DB') || die;

// Paramètres en base de données.
$params = Template::$data['theme']['params'];

// Paramètres par défaut.
if (!is_array($params)
|| !isset($params['style']) || !isset($params['color'])
|| !isset($params['banner']) || !isset($params['background'])
|| !isset($params['buttons']) || !isset($params['css'])
|| !isset($params['thumbs_items']) || !isset($params['display']))
{
	$params =
	[
		'style' => 'clear',
		'style_change' => '0',
		'color' =>
		[
			'clear' => '#3B5EB5',
			'dark' => '#D54949'
		],
		'banner' =>
		[
			'clear' =>
			[
				'type' => 'texture',
				'texture' => 'diamond-upholstery.png',
				'file' => '',
				'height' => '120px'
			],
			'dark' =>
			[
				'type' => 'texture',
				'texture' => 'diamond-upholstery.png',
				'file' => '',
				'height' => '120px'
			]
		],
		'background' =>
		[
			'clear' =>
			[
				'type' => 'border',
				'fixed' => '1',
				'texture' => 'swirl-pattern.png',
				'file' => ''
			],
			'dark' =>
			[
				'type' => 'border',
				'fixed' => '1',
				'texture' => 'stardust.png',
				'file' => '',
				'internal_hatches' => '0'
			]
		],
		'buttons' =>
		[
			'clear' =>
			[
				'style' => '1'
			],
			'dark' =>
			[
				'style' => '1'
			]
		],
		'css' =>
		[
			'clear' => '',
			'dark' => ''
		],
		'menu' =>
		[
			'width' => '100'
		],
		'text' =>
		[
			'size' => '100'
		],
		'thumbs_cat' =>
		[
			'layout' => 'landscape'
		],
		'thumbs_items' =>
		[
			'layout' => 'standard'
		],
		'display' =>
		[
			'item_pagination_bottom' => '1',
			'item_pagination_top' => '0',
			'item_prev_next' => '1',
			'item_properties' => '1',
			'item_stats' => '1',
			'item_title' => '1',
			'item_user' => '1',
			'menu' => '1',
			'menu_home' => '1'
		]
	];
}

// Version 3.0.7.
if (!isset($params['background']['dark']['internal_hatches']))
{
	$params['background']['dark']['internal_hatches'] = '0';
}

// Version 3.0.9.
$params['color']['clear'] = '#' . str_replace('#', '', (string) $params['color']['clear']);
$params['color']['dark'] = '#' . str_replace('#', '', (string) $params['color']['dark']);

// Version 3.0.10.
if (!isset($params['background']['clear']['file']))
{
	$params['background']['clear']['file'] = '';
}
if (!isset($params['background']['dark']['file']))
{
	$params['background']['dark']['file'] = '';
}

// Version 3.0.11.
if (!isset($params['display']['item_user']))
{
	$params['display']['item_user'] = '1';
}

// Version 3.0.12.
if (!isset($params['display']['menu_home']))
{
	$params['display']['menu_home'] = '1';
}

// Version 3.0.16.
if (!isset($params['thumbs_cat']))
{
	$params['thumbs_cat'] = ['layout' => 'landscape'];
}

// Version 3.0.17.
if (!isset($params['text']))
{
	$params['text'] = ['size' => '100'];
}
if (!isset($params['menu']))
{
	$params['menu'] = ['width' => '100'];
}

// Version 3.0.18.
if (!isset($params['style_change']))
{
	$params['style_change'] = '0';
}

$theme_edit = $tpl['user']['admin'] || $params['style_change'];
Template::set('theme', ['style' => $params['style']]);
Template::set('theme', ['user_style' => $params['style']]);
Template::set('theme', ['user_style_change' => (int) $params['style_change']]);

// Style utilisateur.
if ($params['style_change'] && is_object(Auth::$prefs))
{
	$style = (string) Auth::$prefs->read('theme_default_user_style');
	if (in_array($style, ['clear', 'dark']))
	{
		Template::set('theme', ['user_style' => $params['style'] = $style]);
	}
}

// Convertit la couleur au format RGB, afin de ne pas la confondre
// avec d'autres couleurs lors de modifications par Javascript.
$color = substr($params['color'][$params['style']], 1);
$color = preg_match('`^[a-f\d]{6}$`i', $color) ? $color : 'B68D2A';
list($r, $g, $b) = sscanf($color, '%02x%02x%02x');
$color = "rgb($r, $g, $b)";

// Réduction du code CSS et application de la couleur du thème.
$css_minify = function($file) use (&$color)
{
	$css = file_get_contents(__DIR__ . '/../style/' . $file);

	// Suppression des commentaires.
	$css = preg_replace('`/\*[\s\S]*?\*/`', '', $css);

	// Suppression des sauts de ligne et des tabulations.
	$css = str_replace(["\n", "\r", "\t"], '', $css);

	// Réduction et suppression des espaces inutiles.
	$css = preg_replace('`\s+`', ' ', $css);
	$css = preg_replace('`([:,])\s`', '$1', $css);

	// Couleur.
	$css = preg_replace('`rgb\(\d+,\s*\d+,\s*\d+\)`i', $color, $css);

	return $css;
};

// Liste des textures disponibles.
$textures =
[
	'banner' =>
	[
		'clear' =>
		[
			'cubes.png' => '',
			'diamond-upholstery.png' => '',
			'dimension.png' => '',

			'foggy-birds.png' => '',
			'food.png' => '',
			'green-gobbler.png' => '',

			'light-wool.png' => '',
			'starring.png' => '',
			'tiny-grid.png' => ''
		],
		'dark' =>
		[
			'brushed-alum.png' => '#111',
			'climpek.png' => '#4c4c4c',
			'cubes.png' => '#4c4c4c',

			'diamond-upholstery.png' => '#3c3c3c',
			'dimension.png' => '#4c4c4c',
			'escheresque.png' => '#111',

			'foggy-birds.png' => '#4c4c4c',
			'light-wool.png' => '#4c4c4c',
			'subtle-stripes.png' => '#4c4c4c'
		]
	],
	'background' =>
	[
		'clear' =>
		[
			'arches.png' => '#fff',
			'batthern.png' => '#fff',
			'climpek.png' => '#fff',

			'dimension.png' => '#fff',
			'food.png' => '#fff',
			'hatches.png' => '#fff',

			'memphis-colorful.png' => '#fff',
			'swirl-pattern.png' => '#fff',
			'washi.png' => '#fff',

			'squares-2.png' => '#fff',
			'squares-15.png' => '#fff',
			'squares-30.png' => '#fff'
		],
		'dark' =>
		[
			'black-mamba.png' => '#111',
			'simple-dashed.png' => '#111',
			'stardust.png' => '#111'
		]
	]
];

// Répertoires.
$banners_dir = CONF_GALLERY_PATH . '/images/banners/';
$background_dir = CONF_GALLERY_PATH . '/images/background/';
$textures_dir = CONF_GALLERY_PATH . '/images/textures/';

// Données de template des options du thème.
if ($theme_edit)
{
	// Palette et textures.
	if ($tpl['user']['admin'])
	{
		Template::set('theme', ['palette' =>
		[
			'#575757', '#966B3C', '#877240', '#888040', '#7F8840', '#61893D', '#3D8946',
			'#828282', '#977857', '#877B5A', '#9D933F', '#8F9D3F', '#76A64B', '#5FA567',
			'#3A8E67', '#369291', '#328296', '#3B7AB5', '#3B5EB5', '#584EB5', '#873D9F',
			'#37A575', '#2DAEB5', '#159DC4', '#6492D8', '#738DE0', '#7E6EB8', '#B577DD',
			'#9D3DA6', '#B52262', '#E85392', '#D22828', '#D85C18', '#CD842D', '#C89418',
			'#D15CD9', '#D575BB', '#DE6CAC', '#D54949', '#D55949', '#D47149', '#C47E2C'
		]]);
	}
	Template::set('theme', ['textures_dir' => $textures_dir]);
	Template::set('theme', ['textures_json' => Utility::jsonEncode($textures)]);

	// Bannières et fonds.
	foreach (['banners', 'background'] as $name)
	{
		if ($tpl['user']['admin'])
		{
			$files = [];
			foreach (scandir(GALLERY_ROOT . '/images/' . $name) as $f)
			{
				if (preg_match('`^[a-z0-9_-]{1,250}\.(gif|jpe?g|png|webp)$`i', $f))
				{
					$files[] = $f;
				}
			}
			Template::set('theme', [$name => $files]);
		}
		Template::set('theme', [$name . '_dir' => ${$name . '_dir'}]);
	}
}

// Paramètres du thème au format JSON.
Template::set('theme', ['params_json' => Utility::jsonEncode($params)]);

// CSS : couleur.
echo $css_minify('color.css');

// CSS : style sombre.
if ($params['style'] == 'dark')
{
	$css_dark = $css_minify('dark.css');
	echo $theme_edit ? '/*<dark>*/' . $css_dark . '/*</dark>*/' : $css_dark;
}
else if ($theme_edit)
{
	echo '/*<dark>*//*' . $css_minify('dark.css') . '*//*</dark>*/';
}

// CSS : fond interne hachuré (style sombre uniquement).
$is_hatches = $params['style'] == 'dark' && $params['background']['dark']['type'] != 'none'
	&& $params['background']['dark']['internal_hatches'] == 1;
if ($theme_edit || $is_hatches)
{
	$start = $end = '';
	if ($theme_edit)
	{
		$start = '/*<internal_hatches>*/';
		$end = '/*</internal_hatches>*/';
		if (!$is_hatches)
		{
			$start = $start . '/*';
			$end = '*/' . $end;
		}
	}
	printf('%sbody.bg #gallery_inner{background-image:url(data:image/png;base64,'
		. 'iVBORw0KGgoAAAANSUhEUgAAAA0AAAANCAYAAABy6+R8AAAAH0lEQVQokWNgIAHY29v/'
		. 't7e3/z+qYVQDpRpgmkhVDwCXwS0Z8PUhagAAAABJRU5ErkJggg==);}%s', $start, $end);
}

// CSS : boutons de formulaires (style clair).
if ($theme_edit
|| ($params['buttons'][$params['style']]['style'] == '2' && $params['style'] == 'clear'))
{
	$start = $end = '';
	if ($theme_edit)
	{
		$start = '/*<buttons_style_2_clear>*/';
		$end = '/*</buttons_style_2_clear>*/';
		if ($params['buttons'][$params['style']]['style'] != '2' || $params['style'] != 'clear')
		{
			$start = $start . '/*';
			$end = '*/' . $end;
		}
	}
	$css = '.button,.button:active,.button:focus,.button:hover{'
		. 'background:%3$s;border:2px solid %3$s;padding:6px 12px;border-radius:20px;'
		. 'color:white;box-shadow:none;}.button:active,.button:focus,.button:hover'
		. '{color:%3$s;background:white;}.button:active{box-shadow:0 0 8px gray;}';
	printf('%1$s' . $css . '%2$s', $start, $end, $color);
}

// CSS : boutons de formulaires (style sombre).
if ($theme_edit
|| ($params['buttons'][$params['style']]['style'] == '2' && $params['style'] == 'dark'))
{
	$start = $end = '';
	if ($theme_edit)
	{
		$start = '/*<buttons_style_2_dark>*/';
		$end = '/*</buttons_style_2_dark>*/';
		if ($params['buttons'][$params['style']]['style'] != '2' || $params['style'] != 'dark')
		{
			$start = $start . '/*';
			$end = '*/' . $end;
		}
	}
	$css = '.button,.button:active,.button:focus,.button:hover{border-radius:20px;'
		. 'outline:none;}.button,.button:active.button:hover:active{padding:6px 12px;'
		. 'border:2px solid %3$s;}.button:focus,.button:hover{padding:8px 14px;border:0;}';
	printf('%1$s' . $css . '%2$s', $start, $end, $color);
}

// CSS pour écrans larges.
$css_large_screen = '';

// CSS : bannière, hauteur.
$start = $end = '';
if ($theme_edit)
{
	$start = '/*<banner_height>*/';
	$end = '/*</banner_height>*/';
}
$css_large_screen .= sprintf(
	'%sheader.banner #header_top{height:%s}%s',
	$start, $params['banner'][$params['style']]['height'], $end
);

// CSS : image de bannière ?
$is_banner_image = $params['banner'][$params['style']]['type'] == 'file'
				|| $params['banner'][$params['style']]['type'] == 'texture';

// CSS : bannière, couleur.
$is_banner_color = $params['banner'][$params['style']]['type'] == 'color';

// CSS : bannière, texture.
if ($theme_edit || $params['banner'][$params['style']]['type'] == 'texture')
{
	$file = $params['banner'][$params['style']]['texture'];
	$banner_color = $textures['banner'][$params['style']][$file];
	if (!$banner_color)
	{
		$banner_color = $params['color'][$params['style']];
	}
	$start = $end = '';
	if ($theme_edit)
	{
		$start = '/*<banner_texture>*/';
		$end = '/*</banner_texture>*/';
		if ($params['banner'][$params['style']]['type'] != 'texture')
		{
			$start = $start . '/*';
			$end = '*/' . $end;
		}
	}
	$css_large_screen .= sprintf(
		'%sheader.banner #header_top{background:%s url(%s%s)}%s',
		$start, $banner_color, $textures_dir, $file, $end
	);
}

// CSS : bannière, fichier.
if ($theme_edit || $params['banner'][$params['style']]['type'] == 'file')
{
	$start = $end = '';
	if ($theme_edit)
	{
		$start = '/*<banner_file>*/';
		$end = '/*</banner_file>*/';
		if ($params['banner'][$params['style']]['type'] != 'file')
		{
			$start = $start . '/*';
			$end = '*/' . $end;
		}
	}
	$file = $params['banner'][$params['style']]['file'] ?? '';
	$css_large_screen .= sprintf(
		'%sheader.banner #header_top{background-image:url(%s%s)}%s',
		$start, $banners_dir, $file, $end
	);
}

// CSS : fond ?
$is_background = $params['background'][$params['style']]['type'] != 'none';

// CSS : fond, texture.
if ($theme_edit || $params['background'][$params['style']]['type'] == 'texture')
{
	$start = $end = '';
	if ($theme_edit)
	{
		$start = '/*<background_texture>*/';
		$end = '/*</background_texture>*/';
		if ($params['background'][$params['style']]['type'] != 'texture')
		{
			$start = $start . '/*';
			$end = '*/' . $end;
		}
	}
	$fixed = $params['background'][$params['style']]['fixed'] == 1 ? 'fixed' : '';
	$file = $params['background'][$params['style']]['texture'];
	$bg_color = $textures['background'][$params['style']][$file] ?? '';
	$css_large_screen .= sprintf(
		'%sbody.bg{background:%s %s url(%s%s)}%s',
		$start, $fixed, $bg_color, $textures_dir, $file, $end
	);
}

// CSS : fond, fichier.
if ($theme_edit || $params['background'][$params['style']]['type'] == 'file')
{
	$start = $end = '';
	if ($theme_edit)
	{
		$start = '/*<background_file>*/';
		$end = '/*</background_file>*/';
		if ($params['background'][$params['style']]['type'] != 'file')
		{
			$start = $start . '/*';
			$end = '*/' . $end;
		}
	}
	$fixed = $params['background'][$params['style']]['fixed'] == 1 ? 'fixed' : '';
	$file = $params['background'][$params['style']]['file'] ?? '';
	$css_large_screen .= sprintf(
		'%sbody.bg{background:%s url(%s%s)}%s',
		$start, $fixed, $background_dir, $file, $end
	);
}

// CSS : largeur du menu.
if ($theme_edit || $params['menu']['width'] != '100')
{
	$start = $end = '';
	if ($theme_edit)
	{
		$start = '/*<menu_width>*/';
		$end = '/*</menu_width>*/';
	}
	$css_large_screen .= sprintf(
		'%s#menu{max-width:%s;}%s',
		$start, $params['menu']['width'] . '%', $end
	);
}

printf('@media(min-width:1180px){%s}', $css_large_screen);

// CSS : code personnalisé.
$tags = ['#color', '#gallery_path'];
$tags_replace = [$color, $tpl['gallery']['path']];
$css = preg_replace_callback(
	'`(\{(?:[\s\S](?![{}]))*?)(' . implode('|', $tags) . ')((?:[\s\S](?![{]))*?\})`i',
	function($m) use ($color, $tags, $tags_replace)
	{
		return str_ireplace($tags, $tags_replace, $m[0]);
	},
	$params['css'][$params['style']]
);
$css = str_replace(['&#039;', '&quot;', '&gt;'], ["'", '"', '>'], $css);
$css = $theme_edit ? '/*<css_code>*/' . $css . '/*</css_code>*/' : $css;
echo $css;

// CSS : taille du texte.
if ($theme_edit || $params['text']['size'] != '100')
{
	$start = $end = '';
	if ($theme_edit)
	{
		$start = '/*<text_size>*/';
		$end = '/*</text_size>*/';
	}
	$add = '';
	switch ($params['text']['size'])
	{
		case '120' :
			$add = '#menu #menu_gallery.browse::before{top:7px}';
			break;
	}
	printf(
		'%shtml,table,input,textarea,select{font-size:%s;}%s%s',
		$start, $params['text']['size'] . '%', $add, $end
	);
}

// Type d'affichage des vignettes.
$thumbs_cat_layout = $params['thumbs_cat']['layout'];
$thumbs_items_layout = $params['thumbs_items']['layout'];

// Dimensions des vignettes.
switch ($thumbs_items_layout)
{
	case 'portrait' :
		$thumbs_items_size = '161x241';
		break;
	case 'square' :
		$thumbs_items_size = '161x161';
		break;
	default :
		$thumbs_items_size = '151';
		break;
}
switch ($thumbs_cat_layout)
{
	case 'portrait' :
		$thumbs_cat_size = '232x348';
		break;
	case 'square' :
		$thumbs_cat_size = '232x232';
		break;
	default :
		$thumbs_cat_size = '232x167';
		break;
}

// Éléments à afficher.
foreach ($params['display'] as $k => $v)
{
	${'display_' . $k} = (bool) $params['display'][$k];
}
?>